#pragma once

#ifdef AUTODESK_3DSMAX
#include <point3.h>
#include <matrix3.h>
#include <mesh.h>
#include <box3.h>
#include <bitarray.h>
#include <imtl.h>

namespace Ephere { namespace Plugins { namespace Ornatrix
{

struct MaxTriangleMeshAccess
{
	::Mesh* mesh;
	bool isReadOnly;
	bool isEditingTopology;
	bool isEditingGeometry;
	bool isEditingNormals;
};

typedef float Real;
typedef ::Point2 HostVector2;
typedef ::Point3 HostVector3;
typedef ::UVVert HostTextureCoordinate;
typedef ::Matrix3 HostXform3;
typedef ::Mesh HostTriangleMesh;
typedef ::Face HostTriangleFace;
typedef ::TVFace HostTriangleTextureFace;
typedef ::Box3 HostAxisAlignedBox3;
typedef ::BitArray HostElementSelection;
typedef ::Texmap HostTextureMap;
typedef MaxTriangleMeshAccess HostTriangleMeshAccessHandle;

} } }
#endif