#pragma once

#ifdef AUTODESK_MAYA
#include <maya/MPoint.h>
#include <maya/MTransformationMatrix.h>
#include <maya/MBoundingBox.h>
#include <maya/MObject.h>
#include <maya/MIntArray.h>
#include <maya/MImage.h>
#include <vector>

#define MSTR(s)		( ::std::string( (const char*) s ) )

namespace Ephere { namespace Plugins
{

namespace Autodesk { namespace Maya { namespace Ornatrix
{

class TextureAccess;
class TriangleMeshAccess;

} } }
	
namespace Ornatrix
{

typedef double Real;
typedef ::MPoint HostVector2;					// actually 4
typedef ::MPoint HostVector3;					// actually 4
typedef ::MPoint HostTextureCoordinate;			// actually 4
typedef ::MTransformationMatrix HostXform3;		// actually 4x4
typedef ::MObject HostTriangleMesh;				// MFn::Type = kMesh?
typedef ::MIntArray HostTriangleFace;			// 3 indices of triangle vertices
typedef ::MIntArray HostTriangleTextureFace;	// 3 indices of triangle vertices
typedef ::MBoundingBox HostAxisAlignedBox3;
typedef std::vector<bool> HostElementSelection;
typedef ::MImage HostTextureMap;
typedef Ephere::Plugins::Autodesk::Maya::Ornatrix::TextureAccess* HostTextureAccessHandle;
typedef Ephere::Plugins::Autodesk::Maya::Ornatrix::TriangleMeshAccess* HostTriangleMeshAccessHandle;

} } }
#endif