#pragma once

namespace Ephere { namespace Plugins { namespace Ornatrix
{

//! Using dependency on 3 guides (max)
#define MAX_GUIDE_INTERPOLATION_COUNT 3

/** Guide dependency struct:
	Mostly used with hair this class allows every hair strand to point to the guide that it depends on.
	Most useful implementation for this is channel inheritance, but it can be also used for updating strand
	shape, export to game engines, and hair hierarchy maintenance
*/
struct GuideDependency
{
	//! Index of MAX_GUIDE_INTERPOLATION_COUNT closest guides
	unsigned closestRootIndices[MAX_GUIDE_INTERPOLATION_COUNT];

	//! Distances to MAX_GUIDE_INTERPOLATION_COUNT closest guides
	float closestRootDistances[MAX_GUIDE_INTERPOLATION_COUNT];
};

} } } // Ephere::Plugins::Ornatrix