#pragma once

#include "Ephere/Plugins/AutodeskMaxTypes.h"
#include "Ephere/Plugins/AutodeskMayaTypes.h"
#include "IHairRenderingProperties.h"

namespace Ephere { namespace Plugins { namespace Ornatrix
{

class HairRenderingProperties : public IHairRenderingProperties
{
public:

	inline HairRenderingProperties();

	// From IHairRenderingProperties:

	inline bool IsUsed() const;

	inline void SetUsed( bool value );

	inline unsigned short GetStrandGroupIndex() const;

	inline void SetStrandGroupIndex( unsigned short value );

	inline float GetGlobalStrandRadius() const;

	inline void SetGlobalStrandRadius( float value );

	inline HostTextureMap* GetRadiusMap() const;

	inline void SetRadiusMap( HostTextureMap* value );

	inline unsigned GetRadiusStrandDataChannel() const;

	inline void SetRadiusStrandDataChannel( unsigned value );

	inline const IFunction1* GetRadiusCurve() const;

	inline void SetRadiusCurve( const IFunction1* curve );

	inline bool IsUsingSelfShadowing() const;

	inline void SetUsingSelfShadowing( bool value );

	inline float GetSelfShadowingCoefficient() const;

	inline void SetSelfShadowingCoefficient( float value );

private:

	bool isUsed_;

	unsigned short strandGroup_;

	float globalStrandRadius_;

	HostTextureMap* radiusMap_;

	unsigned radiusStrandDataChannel_;

	const IFunction1* radiusCurve_;

	bool usesSelfShadowing_;

	float selfShadowingCoefficient_;

};

} } } // namespace Ephere::Plugins::Ornatrix

#include "HairRenderingProperties.inl"