#include "HairRenderingProperties.h"

namespace Ephere { namespace Plugins { namespace Ornatrix
{

HairRenderingProperties::HairRenderingProperties():
	isUsed_( true ),
	strandGroup_( 0 ),
	globalStrandRadius_( 0.5f ),
	radiusMap_( nullptr ),
	radiusStrandDataChannel_( 0 ),
	radiusCurve_( nullptr ),
	usesSelfShadowing_( true ),
	selfShadowingCoefficient_( 1.0f )
{
}

bool HairRenderingProperties::IsUsed() const
{
	return isUsed_;
}

void HairRenderingProperties::SetUsed( bool value )
{
	isUsed_ = value;
}

unsigned short HairRenderingProperties::GetStrandGroupIndex() const
{
	return strandGroup_;
}

void HairRenderingProperties::SetStrandGroupIndex( unsigned short value )
{
	strandGroup_ = value;
}

float HairRenderingProperties::GetGlobalStrandRadius() const
{
	return globalStrandRadius_;
}

void HairRenderingProperties::SetGlobalStrandRadius( float value )
{
	globalStrandRadius_ = value;
}

Ephere::Plugins::HostTextureMap* HairRenderingProperties::GetRadiusMap() const
{
	return radiusMap_;
}

void HairRenderingProperties::SetRadiusMap( HostTextureMap* value )
{
	radiusMap_ = value;
}

unsigned HairRenderingProperties::GetRadiusStrandDataChannel() const
{
	return radiusStrandDataChannel_;
}

void HairRenderingProperties::SetRadiusStrandDataChannel( unsigned value )
{
	radiusStrandDataChannel_ = value;
}

const Ephere::Plugins::Ornatrix::IFunction1* HairRenderingProperties::GetRadiusCurve() const
{
	return radiusCurve_;
}

void HairRenderingProperties::SetRadiusCurve( const IFunction1* curve )
{
	radiusCurve_ = curve;
}

bool HairRenderingProperties::IsUsingSelfShadowing() const
{
	return usesSelfShadowing_;
}

void HairRenderingProperties::SetUsingSelfShadowing( bool value )
{
	usesSelfShadowing_ = value;
}

float HairRenderingProperties::GetSelfShadowingCoefficient() const
{
	return selfShadowingCoefficient_;
}

void HairRenderingProperties::SetSelfShadowingCoefficient( float value )
{
	selfShadowingCoefficient_ = value;
}

} } } // namespace Ephere::Plugins::Ornatrix