#pragma once

namespace Ephere { namespace Plugins { namespace Ornatrix
{

// forward declares:
class IHairRenderingProperties;

//! Interface to a class containing IHairRenderingProperties
class IHairRenderingPropertiesContainer
{
public:

	/** Gets hair rendering properties for specified strand group index
		@param strandGroupIndex Index of the strand group for which to get the rendering properties
		@return Rendering properties or null if no properties exist for the specified group
	*/
	virtual const IHairRenderingProperties* GetHairRenderingProperties( unsigned short strandGroupIndex ) const = 0;

	/** Gets hair rendering properties for specified strand group index
		@param strandGroupIndex Index of the strand group for which to get the rendering properties
		@return Rendering properties or null if no properties exist for the specified group
	*/
	inline IHairRenderingProperties* GetHairRenderingProperties( unsigned short strandGroupIndex )
	{
		return const_cast<IHairRenderingProperties*>( static_cast<const IHairRenderingPropertiesContainer&>( *this ).GetHairRenderingProperties( strandGroupIndex ) );
	}
	
};

} } } // Ephere::Plugins::Ornatrix