#pragma once

#include "Ephere/Plugins/AutodeskMaxTypes.h"
#include "Ephere/Plugins/AutodeskMayaTypes.h"

namespace Ephere { namespace Plugins { namespace Ornatrix
{

/** Surface dependency:
	This class is optional for hair but mandatory to guides. It is required to update root position based
	on the deforming surface, to get correct UVW coordinates, and surface normal to generate strand transformations
*/
struct SurfaceDependency
{
public:

	inline SurfaceDependency();

	inline SurfaceDependency( unsigned short group, unsigned face, HostVector3 barycentricCoordinate );

	//! Strand group index (if propagation is used)
	unsigned short group;

	//! Index into mesh face list
	unsigned face;

	//! Barycentric coordinates of this root on face
	HostVector3 barycentricCoordinate;
};

} } } // Ephere::Plugins::Ornatrix

#include "SurfaceDependency.inl"